Overview

SpreadJS provides cell types. It can support two-way binding (data changes in the view model are reflected in the view). Each cell type provides two modes: display mode and edit mode. These cell types allow you to customize the way that specific cells behave, and gives you control over the different types of input that you might want for your application.

Description
app.js
index.html
styles.css
Copy to CodeMine

To set the cell type, first create a cellType object, then use the setCellType method to set the cellType for the sheet, cell, column, or row. For example:

    var b1 = new GC.Spread.Sheets.CellTypes.Button();
    b1.text('Margin Left');
    b1.marginLeft(40);
    sheet.setCellType(3, 2, b1, GC.Spread.Sheets.SheetArea.viewport);
    //or
    sheet.getCell(3,2).cellType(b1);

Sometimes you can use the cellType with data binding by binding a cellType to a column. For example:

    var lines = ['Computers', 'Washers', 'Stoves'];
    var lineCellType = new GC.Spread.Sheets.CellTypes.ComboBox();
    lineCellType.items(lines);
    var columns = [
       {name: 'name', size: 100}
       {name: 'color', cellType: lineCellType, size: 80},
    ];
    sheet.bindColumns(columns)
    b1.marginLeft(40);

After you set the cell type you can use the getCellType method to get the cell type. If you want to remove the cell type, set the value to null or undefined.

SpreadJS provides an event (ButtonClicked) on the spreadsheet. The event occurs when you click a button, check box, or hyperlink in a cell. For example:

    spread.bind(GC.Spread.Sheets.Events.ButtonClicked, function() {
       //do some thing...
    });
To set the cell type, first create a cellType object, then use the setCellType method to set the cellType for the sheet, cell, column, or row. For example: Sometimes you can use the cellType with data binding by binding a cellType to a column. For example: After you set the cell type you can use the getCellType method to get the cell type. If you want to remove the cell type, set the value to null or undefined. SpreadJS provides an event (ButtonClicked) on the spreadsheet. The event occurs when you click a button, check box, or hyperlink in a cell. For example:
window.onload = function () { var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), { sheetCount: 2 }); initSpread(spread); }; function initSpread(spread) { var spreadNS = GC.Spread.Sheets, sheet = spread.getSheet(0); var eventTrigger = document.getElementById("eventTrigger"); spread.bind(spreadNS.Events.ButtonClicked, function (e, args) { var text = ""; if (eventTrigger.value === "undefined"){ eventTrigger.value = ""; } var sheet = args.sheet, row = args.row, col = args.col; var cellType = sheet.getCellType(row, col); if (cellType instanceof GC.Spread.Sheets.CellTypes.Button) { text = eventTrigger.value + "You click a button.\n"; } if (cellType instanceof GC.Spread.Sheets.CellTypes.CheckBox) { text = eventTrigger.value + "You click a check box.\n"; } if (cellType instanceof GC.Spread.Sheets.CellTypes.HyperLink) { text = eventTrigger.value + "You click a hyperlink.\n"; } eventTrigger.value=text; }); spread.bind(spreadNS.Events.CellClick, function (e, args) { var text = ""; if (eventTrigger.value === "undefined"){ eventTrigger.value = ""; } var sheet = args.sheet, row = args.row, col = args.col; var cellType = sheet.getCellType(row, col); if (cellType instanceof GC.Spread.Sheets.CellTypes.ComboBox) { text = eventTrigger.value + "You click a combo box.\n"; } eventTrigger.value=text; }); sheet.suspendPaint(); sheet.name('Basic Usage'); sheet.setColumnWidth(2, 140); sheet.setColumnWidth(1, 120); sheet.setRowHeight(1, 50); var b0 = new spreadNS.CellTypes.Button(); b0.text("Margin"); b0.marginLeft(15); b0.marginTop(7); b0.marginRight(15); b0.marginBottom(7); sheet.setCellType(1, 2, b0, spreadNS.SheetArea.viewport); sheet.setValue(1, 1, "ButtonCellType"); var c = new spreadNS.CellTypes.CheckBox(); c.isThreeState(false); c.textTrue("Checked!"); c.textFalse("Check Me!"); sheet.setCellType(2, 2, c, spreadNS.SheetArea.viewport); sheet.setValue(2, 1, "CheckBoxCellType"); var combo = new spreadNS.CellTypes.ComboBox(); combo.items([{ text: "Oranges", value: "11k" }, { text: "Apples", value: "15k" }, { text: "Grape", value: "100k" }]); combo.editorValueType(spreadNS.CellTypes.EditorValueType.text); sheet.getCell(3, 2, spreadNS.SheetArea.viewport).cellType(combo).value("Grape"); sheet.setValue(3, 1, "ComboBoxCellType"); var h = new spreadNS.CellTypes.HyperLink(); h.text("SpreadJS Overview"); sheet.setCellType(4, 2, h, spreadNS.SheetArea.viewport); sheet.getCell(4, 2, spreadNS.SheetArea.viewport).value("http://developer.mescius.com/en/spreadjs/").hAlign(spreadNS.HorizontalAlign.center); sheet.setValue(4, 1, "HyperLinkCellType"); sheet.resumePaint(); var sheet1 = spread.getSheet(1); sheet1.name('DataBind'); sheet1.suspendPaint(); var _lines = ["Computers", "Washers", "Stoves"]; var _colors = ["Red", "Green", "Blue", "White"]; var _ratings = ["Terrible", "Bad", "Average", "Good", "Great", "Epic"]; var lineCellType = new spreadNS.CellTypes.ComboBox(); lineCellType.items(_lines); var colorCellType = new spreadNS.CellTypes.ComboBox(); colorCellType.items(_colors); var checkBoxCellType = new spreadNS.CellTypes.CheckBox(); var ratingCellType = new spreadNS.CellTypes.ComboBox(); ratingCellType.items(_ratings); var datasource = [ { name: "Stoves S0", line: "Washers", color: "Green", discontinued: true, rating: "Average" }, { name: "Computers C1", line: "Washers", color: "Green", discontinued: true, rating: "Average" }, { name: "Washers W3", line: "Washers", color: "Green", discontinued: true, rating: "Average" } ]; var colInfos = [ { name: "name", size: 100 }, { name: "line", cellType: lineCellType, size: 80 }, { name: "color", cellType: colorCellType }, { name: "discontinued", cellType: checkBoxCellType, size: 80 }, { name: "rating", cellType: ratingCellType } ]; sheet1.autoGenerateColumns = false; sheet1.setDataSource(datasource); sheet1.bindColumns(colInfos); sheet1.resumePaint(); };
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> <div class="options-container"> This text box will display information about the different cell types that are interacted with. <div class="option-row"> <textarea id="eventTrigger" style="width: 100%; height: 120px"></textarea> </div> </div> </div> </body> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 280px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 280px; overflow: auto; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; } .option-row { padding-bottom: 8px; } label { padding-bottom: 4px; display: block; } input { width: 100%; padding: 4px 8px; box-sizing: border-box; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }

To set the cell type, first create a cellType object, then use the setCellType method to set the cellType for the sheet, cell, column, or row. For example:
Sometimes you can use the cellType with data binding by binding a cellType to a column. For example:
After you set the cell type you can use the getCellType method to get the cell type. If you want to remove the cell type, set the value to null or undefined.
SpreadJS provides an event (ButtonClicked) on the spreadsheet. The event occurs when you click a button, check box, or hyperlink in a cell. For example:
// @ts-ignore
import { Component, NgModule, enableProdMode } from '@angular/core';
// @ts-ignore
import { BrowserModule } from '@angular/platform-browser';
// @ts-ignore
import { FormsModule } from '@angular/forms';
// @ts-ignore
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
// @ts-ignore
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
// @ts-ignore
import GC from '@mescius/spread-sheets';
import { getData } from "./app.data";
import './styles.css';
const spreadNS = GC.Spread.Sheets;
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
datasource = getData();
message = '';
sheet: GC.Spread.Sheets.Worksheet;
initSpread($event: any) {
const spread = $event.spread;
const GCsheets = GC.Spread.Sheets;
const sheet = spread.getSheet(0);
spread.bind(GCsheets.Events.ButtonClicked, (e: MouseEvent, args: any) => {
const { sheet, row, col } = args;
const cellType = sheet.getCellType(row, col);
if (cellType instanceof GCsheets.CellTypes.Button) {
this.message += "You click a button.\n";
}
if (cellType instanceof GCsheets.CellTypes.CheckBox) {
this.message += "You click a check box.\n";
}
if (cellType instanceof GCsheets.CellTypes.HyperLink) {
this.message += "You click a hyperlink.\n";
}
});
spread.bind(GCsheets.Events.CellClick, (e: MouseEvent, args: any) => {
const { sheet, row, col } = args;
const cellType = sheet.getCellType(row, col);
if (cellType instanceof GCsheets.CellTypes.ComboBox) {
this.message += "You click a combo box.\n";
}
});
sheet.suspendPaint();
sheet.name('Basic Usage');
sheet.setColumnWidth(2, 140);
sheet.setColumnWidth(1, 120);
sheet.setRowHeight(1, 50);
const b0 = new GCsheets.CellTypes.Button();
b0.text("Margin");
b0.marginLeft(15);
b0.marginTop(7);
b0.marginRight(15);
b0.marginBottom(7);
sheet.setCellType(1, 2, b0, GCsheets.SheetArea.viewport);
sheet.setValue(1, 1, "ButtonCellType");
const c = new GCsheets.CellTypes.CheckBox();
c.isThreeState(false);
c.textTrue("Checked!");
c.textFalse("Check Me!");
sheet.setCellType(2, 2, c, GCsheets.SheetArea.viewport);
sheet.setValue(2, 1, "CheckBoxCellType");
const combo = new GCsheets.CellTypes.ComboBox();
combo.items([{ text: "Oranges", value: "11k" }, { text: "Apples", value: "15k" }, { text: "Grape", value: "100k" }]);
combo.editorValueType(GCsheets.CellTypes.EditorValueType.text);
sheet.getCell(3, 2, GCsheets.SheetArea.viewport).cellType(combo).value("Grape");
sheet.setValue(3, 1, "ComboBoxCellType");
const h = new GCsheets.CellTypes.HyperLink();
h.text("SpreadJS Overview");
sheet.setCellType(4, 2, h, GCsheets.SheetArea.viewport);
sheet.getCell(4, 2, GCsheets.SheetArea.viewport).value("http://developer.mescius.com/en/spreadjs/").hAlign(GCsheets.HorizontalAlign.center);
sheet.setValue(4, 1, "HyperLinkCellType");
sheet.resumePaint();
const sheet1 = spread.getSheet(1);
sheet1.name('DataBind');
sheet1.suspendPaint();
const _lines = ["Computers", "Washers", "Stoves"];
const _colors = ["Red", "Green", "Blue", "White"];
const _ratings = ["Terrible", "Bad", "Average", "Good", "Great", "Epic"];
const lineCellType = new GCsheets.CellTypes.ComboBox();
lineCellType.items(_lines);
const colorCellType = new GCsheets.CellTypes.ComboBox();
colorCellType.items(_colors);
const checkBoxCellType = new GCsheets.CellTypes.CheckBox();
const ratingCellType = new GCsheets.CellTypes.ComboBox();
ratingCellType.items(_ratings);
const colInfos = [
{ name: "name", size: 100 },
{ name: "line", cellType: lineCellType, size: 80 },
{ name: "color", cellType: colorCellType },
{ name: "discontinued", cellType: checkBoxCellType, size: 80 },
{ name: "rating", cellType: ratingCellType }
];
sheet1.bindColumns(colInfos);
sheet1.resumePaint();
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet></gc-worksheet>
<gc-worksheet [dataSource]="datasource" [autoGenerateColumns]="autoGenerateColumns"></gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
This text box will display information about the different cell types that are interacted with.
<div class="option-row">
<textarea id="eventTrigger" style="width: 100%; height: 120px" [(ngModel)]="message"></textarea>
</div>
</div>
</div>
export function getData() {
return [
{ name: "Stoves S0", line: "Washers", color: "Green", discontinued: true, rating: "Average" },
{ name: "Computers C1", line: "Washers", color: "Green", discontinued: true, rating: "Average" },
{ name: "Washers W3", line: "Washers", color: "Green", discontinued: true, rating: "Average" }
]
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
overflow: auto;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
}
.sample-options{
z-index: 1000;
}
.option {
padding-bottom: 6px;
}
.checkbox {
padding-right: 12px;
display: inline-block;
}
label {
display: inline-block;
min-width: 100px;
}
input, select {
width: 100%;
padding: 4px 0;
margin-top: 4px;
box-sizing: border-box;
}
input[type=checkbox] {
width: auto;
padding: 0;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.2-master-2026-06-10-2131/'
},
// map tells the System loader where to look for things
map: {
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'cdn:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

To set the cell type, first create a cellType object, then use the setCellType method to set the cellType for the sheet, cell, column, or row. For example:
Sometimes you can use the cellType with data binding by binding a cellType to a column. For example:
After you set the cell type you can use the getCellType method to get the cell type. If you want to remove the cell type, set the value to null or undefined.
SpreadJS provides an event (ButtonClicked) on the spreadsheet. The event occurs when you click a button, check box, or hyperlink in a cell. For example:
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import { useState } from 'react';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import GC from '@mescius/spread-sheets';
import './styles.css';
import { getData } from './data';
const Component = React.Component;
let myMessage = "";
const GCsheets = GC.Spread.Sheets;
export function AppFunc() {
const [message, setMessage] = useState(myMessage);
const data = getData();
const autoGenerateColumns = false;
let initSpread = function (spread) {
const sheet = spread.getSheet(0);
bindEvent(spread, setMessage);
sheet.suspendPaint();
sheet.name('Basic Usage');
sheet.setColumnWidth(2, 140);
sheet.setColumnWidth(1, 120);
sheet.setRowHeight(1, 50);
const b0 = new GCsheets.CellTypes.Button();
b0.text("Margin");
b0.marginLeft(15);
b0.marginTop(7);
b0.marginRight(15);
b0.marginBottom(7);
sheet.setCellType(1, 2, b0, GCsheets.SheetArea.viewport);
sheet.setValue(1, 1, "ButtonCellType");
const c = new GCsheets.CellTypes.CheckBox();
c.isThreeState(false);
c.textTrue("Checked!");
c.textFalse("Check Me!");
sheet.setCellType(2, 2, c, GCsheets.SheetArea.viewport);
sheet.setValue(2, 1, "CheckBoxCellType");
const combo = new GCsheets.CellTypes.ComboBox();
combo.items([{ text: "Oranges", value: "11k" }, { text: "Apples", value: "15k" }, { text: "Grape", value: "100k" }]);
combo.editorValueType(GCsheets.CellTypes.EditorValueType.text);
sheet.getCell(3, 2, GCsheets.SheetArea.viewport).cellType(combo).value("Grape");
sheet.setValue(3, 1, "ComboBoxCellType");
const h = new GCsheets.CellTypes.HyperLink();
h.text("SpreadJS Overview");
sheet.setCellType(4, 2, h, GCsheets.SheetArea.viewport);
sheet.getCell(4, 2, GCsheets.SheetArea.viewport).value("http://developer.mescius.com/en/spreadjs/").hAlign(GCsheets.HorizontalAlign.center);
sheet.setValue(4, 1, "HyperLinkCellType");
sheet.resumePaint();
const sheet1 = spread.getSheet(1);
sheet1.name('DataBind');
sheet1.suspendPaint();
const _lines = ["Computers", "Washers", "Stoves"];
const _colors = ["Red", "Green", "Blue", "White"];
const _ratings = ["Terrible", "Bad", "Average", "Good", "Great", "Epic"];
const lineCellType = new GCsheets.CellTypes.ComboBox();
lineCellType.items(_lines);
const colorCellType = new GCsheets.CellTypes.ComboBox();
colorCellType.items(_colors);
const checkBoxCellType = new GCsheets.CellTypes.CheckBox();
const ratingCellType = new GCsheets.CellTypes.ComboBox();
ratingCellType.items(_ratings);
sheet1.setDataSource(data);
const colInfos = [
{ name: "name", size: 100 },
{ name: "line", cellType: lineCellType, size: 80 },
{ name: "color", cellType: colorCellType },
{ name: "discontinued", cellType: checkBoxCellType, size: 80 },
{ name: "rating", cellType: ratingCellType }
];
sheet1.bindColumns(colInfos);
sheet1.resumePaint();
}
return (<div class="sample-tutorial" >
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
<Worksheet></Worksheet>
<Worksheet autoGenerateColumns={autoGenerateColumns}></Worksheet>
</SpreadSheets>
</div>
<Panel panelInfo={message} />
</div>);
}
const bindEvent = (spread, ...fns) => {
const [setMessage] = fns;
spread.bind(GC.Spread.Sheets.Events.ButtonClicked, function (event, args) {
const { sheet, row, col } = args;
const cellType = sheet.getCellType(row, col);
if (cellType instanceof GCsheets.CellTypes.Button) {
myMessage += "You click a button.\n"
}
if (cellType instanceof GCsheets.CellTypes.CheckBox) {
myMessage += "You click a check box.\n"
}
if (cellType instanceof GCsheets.CellTypes.HyperLink) {
myMessage += "You click a hyperlink.\n";
}
setMessage(myMessage);
});
spread.bind(GCsheets.Events.CellClick, (e, args) => {
const { sheet, row, col } = args;
var cellType = sheet.getCellType(row, col);
if (cellType instanceof GCsheets.CellTypes.ComboBox) {
myMessage += "You click a combo box.\n";
}
setMessage(myMessage);
});
}
class Panel extends Component {
constructor(props) {
super(props);
}
render() {
return (
<div class="options-container">
This text box will display information about the different cell types that are interacted with.
<textarea style={{ width: "100%", height: "90px" }} value={this.props.panelInfo}></textarea>
</div>
)
}
}
import * as React from 'react';
import { SpreadSheets, Worksheet} from '@mescius/spread-sheets-react';
import GC from '@mescius/spread-sheets';
import './styles.css';
import { getData } from './data';
const Component = React.Component;
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
this.state = {
message: ''
};
this.data = getData();
this.autoGenerateColumns = false;
}
render() {
return (<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
<Worksheet></Worksheet>
<Worksheet dataSource={this.data} autoGenerateColumns={this.autoGenerateColumns}></Worksheet>
</SpreadSheets>
</div>
<Panel panelinfo={this.state.message} />
</div>);
}
initSpread(spread) {
const GCsheets = GC.Spread.Sheets;
const sheet = spread.getSheet(0);
spread.bind(GCsheets.Events.ButtonClicked, (e, args) => {
const { sheet, row, col } = args;
const cellType = sheet.getCellType(row, col);
if (cellType instanceof GCsheets.CellTypes.Button) {
this.setState((state) => ({
message: state.message + "You click a button.\n"
}));
}
if (cellType instanceof GCsheets.CellTypes.CheckBox) {
this.setState((state) => ({
message: state.message + "You click a check box.\n"
}));
}
if (cellType instanceof GCsheets.CellTypes.HyperLink) {
this.setState((state) => ({
message: state.message + "You click a hyperlink.\n"
}));
}
});
spread.bind(GCsheets.Events.CellClick, (e, args) => {
const { sheet, row, col } = args;
var cellType = sheet.getCellType(row, col);
if (cellType instanceof GCsheets.CellTypes.ComboBox) {
this.setState((state) => ({
message: state.message + "You click a combo box.\n"
}));
}
});
sheet.suspendPaint();
sheet.name('Basic Usage');
sheet.setColumnWidth(2, 140);
sheet.setColumnWidth(1, 120);
sheet.setRowHeight(1, 50);
const b0 = new GCsheets.CellTypes.Button();
b0.text("Margin");
b0.marginLeft(15);
b0.marginTop(7);
b0.marginRight(15);
b0.marginBottom(7);
sheet.setCellType(1, 2, b0, GCsheets.SheetArea.viewport);
sheet.setValue(1, 1, "ButtonCellType");
const c = new GCsheets.CellTypes.CheckBox();
c.isThreeState(false);
c.textTrue("Checked!");
c.textFalse("Check Me!");
sheet.setCellType(2, 2, c, GCsheets.SheetArea.viewport);
sheet.setValue(2, 1, "CheckBoxCellType");
const combo = new GCsheets.CellTypes.ComboBox();
combo.items([{ text: "Oranges", value: "11k" }, { text: "Apples", value: "15k" }, { text: "Grape", value: "100k" }]);
combo.editorValueType(GCsheets.CellTypes.EditorValueType.text);
sheet.getCell(3, 2, GCsheets.SheetArea.viewport).cellType(combo).value("Grape");
sheet.setValue(3, 1, "ComboBoxCellType");
const h = new GCsheets.CellTypes.HyperLink();
h.text("SpreadJS Overview");
sheet.setCellType(4, 2, h, GCsheets.SheetArea.viewport);
sheet.getCell(4, 2, GCsheets.SheetArea.viewport).value("http://developer.mescius.com/en/spreadjs/").hAlign(GCsheets.HorizontalAlign.center);
sheet.setValue(4, 1, "HyperLinkCellType");
sheet.resumePaint();
const sheet1 = spread.getSheet(1);
sheet1.name('DataBind');
sheet1.suspendPaint();
const _lines = ["Computers", "Washers", "Stoves"];
const _colors = ["Red", "Green", "Blue", "White"];
const _ratings = ["Terrible", "Bad", "Average", "Good", "Great", "Epic"];
const lineCellType = new GCsheets.CellTypes.ComboBox();
lineCellType.items(_lines);
const colorCellType = new GCsheets.CellTypes.ComboBox();
colorCellType.items(_colors);
const checkBoxCellType = new GCsheets.CellTypes.CheckBox();
const ratingCellType = new GCsheets.CellTypes.ComboBox();
ratingCellType.items(_ratings);
const colInfos = [
{ name: "name", size: 100 },
{ name: "line", cellType: lineCellType, size: 80 },
{ name: "color", cellType: colorCellType },
{ name: "discontinued", cellType: checkBoxCellType, size: 80 },
{ name: "rating", cellType: ratingCellType }
];
sheet1.bindColumns(colInfos);
sheet1.resumePaint();
}
}
class Panel extends Component {
constructor(props) {
super(props);
}
render() {
return (
<div class="options-container">
This text box will display information about the different cell types that are interacted with.
<textarea style={{ width: "100%", height: "90px" }} value={this.props.panelinfo}></textarea>
</div>
)
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
overflow: auto;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
}
textarea {
width: 100%;
height: 80px;
padding: 6px 12px;
box-sizing: border-box;
}
.sample-options {
z-index: 1000;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
export function getData() {
return [
{ name: "Stoves S0", line: "Washers", color: "Green", discontinued: true, rating: "Average" },
{ name: "Computers C1", line: "Washers", color: "Green", discontinued: true, rating: "Average" },
{ name: "Washers W3", line: "Washers", color: "Green", discontinued: true, rating: "Average" }
]
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.2-master-2026-06-10-2131/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'cdn:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

To set the cell type, first create a cellType object, then use the setCellType method to set the cellType for the sheet, cell, column, or row. For example:
Sometimes you can use the cellType with data binding by binding a cellType to a column. For example:
After you set the cell type you can use the getCellType method to get the cell type. If you want to remove the cell type, set the value to null or undefined.
SpreadJS provides an event (ButtonClicked) on the spreadsheet. The event occurs when you click a button, check box, or hyperlink in a cell. For example:
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet></gc-worksheet>
<gc-worksheet :dataSource="datasource" :autoGenerateColumns="autoGenerateColumns"></gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
This text box will display information about the different cell types that are interacted with.
<div class="option-row">
<textarea id="eventTrigger" style="width: 100%; height: 120px" v-model="message"></textarea>
</div>
</div>
</div>
</template>
<script setup>
import '@mescius/spread-sheets-vue'
import { ref, computed } from 'vue';
import GC from '@mescius/spread-sheets';
import { getData } from "./data.js";
const message = ref('');
const autoGenerateColumns = ref(false);
let sheet = null;
const initSpread = (spread) => {
const GCsheets = GC.Spread.Sheets;
sheet = spread.getSheet(0);
spread.bind(GCsheets.Events.ButtonClicked, (e, args) => {
const { sheet, row, col } = args;
const cellType = sheet.getCellType(row, col);
if (cellType instanceof GCsheets.CellTypes.Button) {
message.value += "You click a button.\n";
}
if (cellType instanceof GCsheets.CellTypes.CheckBox) {
message.value += "You click a check box.\n";
}
if (cellType instanceof GCsheets.CellTypes.HyperLink) {
message.value += "You click a hyperlink.\n";
}
});
spread.bind(GCsheets.Events.CellClick, (e, args) => {
const { sheet, row, col } = args;
const cellType = sheet.getCellType(row, col);
if (cellType instanceof GCsheets.CellTypes.ComboBox) {
message.value += "You click a combo box.\n";
}
});
sheet.suspendPaint();
sheet.name('Basic Usage');
sheet.setColumnWidth(2, 140);
sheet.setColumnWidth(1, 120);
sheet.setRowHeight(1, 50);
const b0 = new GCsheets.CellTypes.Button();
b0.text("Margin");
b0.marginLeft(15);
b0.marginTop(7);
b0.marginRight(15);
b0.marginBottom(7);
sheet.setCellType(1, 2, b0, GCsheets.SheetArea.viewport);
sheet.setValue(1, 1, "ButtonCellType");
const c = new GCsheets.CellTypes.CheckBox();
c.isThreeState(false);
c.textTrue("Checked!");
c.textFalse("Check Me!");
sheet.setCellType(2, 2, c, GCsheets.SheetArea.viewport);
sheet.setValue(2, 1, "CheckBoxCellType");
const combo = new GCsheets.CellTypes.ComboBox();
combo.items([{ text: "Oranges", value: "11k" }, { text: "Apples", value: "15k" }, { text: "Grape", value: "100k" }]);
combo.editorValueType(GCsheets.CellTypes.EditorValueType.text);
sheet.getCell(3, 2, GCsheets.SheetArea.viewport).cellType(combo).value("Grape");
sheet.setValue(3, 1, "ComboBoxCellType");
const h = new GCsheets.CellTypes.HyperLink();
h.text("SpreadJS Overview");
sheet.setCellType(4, 2, h, GCsheets.SheetArea.viewport);
sheet.getCell(4, 2, GCsheets.SheetArea.viewport).value("http://developer.mescius.com/en/spreadjs/").hAlign(GCsheets.HorizontalAlign.center);
sheet.setValue(4, 1, "HyperLinkCellType");
sheet.resumePaint();
const sheet1 = spread.getSheet(1);
sheet1.name('DataBind');
sheet1.suspendPaint();
const _lines = ["Computers", "Washers", "Stoves"];
const _colors = ["Red", "Green", "Blue", "White"];
const _ratings = ["Terrible", "Bad", "Average", "Good", "Great", "Epic"];
const lineCellType = new GCsheets.CellTypes.ComboBox();
lineCellType.items(_lines);
const colorCellType = new GCsheets.CellTypes.ComboBox();
colorCellType.items(_colors);
const checkBoxCellType = new GCsheets.CellTypes.CheckBox();
const ratingCellType = new GCsheets.CellTypes.ComboBox();
ratingCellType.items(_ratings);
const colInfos = [
{ name: "name", size: 100 },
{ name: "line", cellType: lineCellType, size: 80 },
{ name: "color", cellType: colorCellType },
{ name: "discontinued", cellType: checkBoxCellType, size: 80 },
{ name: "rating", cellType: ratingCellType }
];
sheet1.bindColumns(colInfos);
sheet1.resumePaint();
};
const datasource = computed(() => {
return getData();
});
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
overflow: auto;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
}
.sample-options {
z-index: 1000;
}
.option {
padding-bottom: 6px;
}
.checkbox {
padding-right: 12px;
display: inline-block;
}
label {
display: inline-block;
min-width: 100px;
}
input,
select {
width: 100%;
padding: 4px 0;
margin-top: 4px;
box-sizing: border-box;
}
input[type=checkbox] {
width: auto;
padding: 0;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
export function getData() {
return [
{ name: "Stoves S0", line: "Washers", color: "Green", discontinued: true, rating: "Average" },
{ name: "Computers C1", line: "Washers", color: "Green", discontinued: true, rating: "Average" },
{ name: "Washers W3", line: "Washers", color: "Green", discontinued: true, rating: "Average" }
]
}
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.2-master-2026-06-10-2131/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-en': 'cdn:@mescius/spread-sheets-resources-en/index.js',
'@mescius/spread-sheets-vue': 'cdn:@mescius/spread-sheets-vue/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);